// ClientApplet.java

import java.awt.*;

public class ClientApplet extends java.applet.Applet {

  private TextField _nameField, _balanceField;
  private Button _checkBalance;
  private Bank.AccountManager _manager;

  public void init() {
    // Este GUI utiliza un enrejado de 2x2 elementos.
    setLayout(new GridLayout(2, 2, 5, 5));
    // Aadir los cuatro elementos.
    add(new Label("Nombre de la Cuenta"));
    add(_nameField = new TextField());
    add(_checkBalance = new Button("Comprobar Saldo"));
    add(_balanceField = new TextField());
    // Hacel el campo "balance" no editable.
    _balanceField.setEditable(false);
    // Inicializar el ORB (usando el Applet).
    org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(this, null);
    // Localizar un "AccountManager"
    _manager = Bank.AccountManagerHelper.bind(orb, "BankManager");
  }

  public boolean action(Event ev, Object arg) {
    if(ev.target == _checkBalance) {
      // Pedirle al AccountManager que abra una cuenta con un nombre.
      // Coger el nombre del campo "_nameField".
      Bank.Account account = _manager.open(_nameField.getText());
      // Actualizar el balance en el GUI.
      _balanceField.setText(Float.toString(account.balance()));
      return true;
    }
    return false;
  }
}
