import org.omg.CORBA.*;

public class ClienteCORBA 
{
    public static void main(String[] args)
    {
        try {
            // Inicializar el ORB
            ORB orb = ORB.init(args,null);

            // Obtener una referencia al objeto a partir del IOR
            org.omg.CORBA.Object obj = orb.string_to_object( args[0] );
            
            // Hacer un "casting" hacia el objeto que queremos
            Bank.AccountManager manager =
                Bank.AccountManagerHelper.narrow( obj );

            if (manager == null)
            {
                System.err.println("Referencia de tipo inadecuado.");
                System.exit( -1 );
            }

            // Obtener la cuenta del cliente pasado como parmetro
            Bank.Account acc = manager.open( args[1] );

            // Pedir el balance de la cuenta obtenida
            float balance = acc.balance();

            System.out.println("Cliente: " + args[1]);
            System.out.println("Balance: " + balance);
        }
        catch (SystemException e)
        {
            System.err.println(e);
        }
    }
}
