import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;

public class ClienteNaming 
{
    public static void main(String[] args)
    {
        try {
            // Inicializar el ORB
            ORB orb = ORB.init(args,null);

            // Obtener las referencias a servicios iniciales
            String[] servicios = orb.list_initial_services();
            for (int i = 0;i<servicios.length ;i++)
                System.out.println(servicios[i]);
        
            // Obtener el NamingContext raz
            org.omg.CORBA.Object obj =
                orb.resolve_initial_references("NameService");
            NamingContext rootContext =
                NamingContextHelper.narrow( obj );

            if (rootContext == null)
            {
                System.err.println("No hay Naming Service!");
                System.exit( -1 );
            }

            // Crear un nuevo objeto y ligarlo con un nombre
            Bank.AccountManager manager =
                (Bank.AccountManager)new AccountManagerImpl();

            // Conectar con el ORB
            orb.connect( manager );
            System.out.println( orb.object_to_string(manager));

            // Ligar con un nombre
            NameComponent[] AccountManagerName = new NameComponent[1];
            AccountManagerName[0] = new NameComponent("Account Manager","");
            rootContext.rebind(AccountManagerName,manager);

            // Intentar obtenerlo desde el rootContext
            org.omg.CORBA.Object obj2 =
                rootContext.resolve(AccountManagerName);

            // Comprobar si ambas referencias son iguales
            System.out.println (orb.object_to_string(obj2));
        }
        catch (Exception e)
        {
            System.err.println(e);
        }
    }
}
