import java.lang.Object;
import java.net.*;
import java.io.*;

/*
 *
 * ConnectionThread
 *
 */
public class ConnectionThread extends Thread implements Runnable
{
	private Socket socket = null;
	private Servidor parent = null;
	private BufferedInputStream in;
    private BufferedOutputStream out;

	ConnectionThread(Servidor p, Socket s)
	{
		socket = s;
		parent = p;
	}

    public BufferedOutputStream bos() { return out; };

	public void run()
	{
		int bytesRead;
		byte[] buffer = new byte[Servidor.MAX_LEN];

		try
		{
			in = new BufferedInputStream(socket.getInputStream());
			out = new BufferedOutputStream(socket.getOutputStream());

			bytesRead = in.read(buffer,0,Servidor.MAX_LEN);
			while (bytesRead != -1)
			{
				String msg = new String(buffer,0,0,bytesRead);

                parent.broadcast(msg);

				bytesRead = in.read(buffer,0,10);
			}

			System.out.println("Server part closed");
			socket.close();
		    parent.unregister(this);
		} catch (Exception e)
		{
			System.err.println("Excepcin: " + e);
		}
	}
}

