import java.lang.Object;
import java.net.*;
import java.io.*;

/*
 *
 * Servidor (buffered socket)
 *
 */
public class Servidor extends Object
{
    private static int MAX_CLIENTS = 2;
    public static int MAX_LEN = 500;
    private int Clients = 0;
    private ConnectionThread[] tareas;
    private Socket socket = null;

    public static void main(String[] args)
    {
        Servidor serv = new Servidor();
        serv.run();
    }

    public Servidor()
    {
        int i;

        tareas = new ConnectionThread[MAX_CLIENTS];
        for (i=0;i<MAX_CLIENTS;i++)
            tareas[i] = null;

        Clients = 0;
    }

    public void run()
    {
       	PrintStream o = System.out;
        int j;

		try
		{
			o.println("Creando el socket del servidor");
			ServerSocket serverSocket = new ServerSocket(9000);

			while (true)
			{
				o.println("Performing accept");
				socket = serverSocket.accept();

				if (socket != null)
				{
					if (Clients < MAX_CLIENTS)
					{
    					// Create a thread to manage connection
	    				o.println("Creating a server thread");
		    			ConnectionThread t = new 
					    ConnectionThread(this,socket);

    					for (j = 0;j<MAX_CLIENTS;j++)
                            if (tareas[j] == null)
							{
                                tareas[j] = t;
								break;
							}

                        Clients++;
    					t.start();
    				}
    				else
    				    socket.close();
				}
			}

		} catch (Exception e)
		{
			System.err.println("Excepcin: " + e);
		}
	}

	public synchronized void broadcast(String msg)
	{
	    // Send broadcast to all clients
	    int i;
	    byte[] buffer = new byte[MAX_LEN];

		msg.getBytes(0,msg.length(),buffer,0);

	    for(i=0;i< MAX_CLIENTS;i++)
	    {
			if (tareas[i] != null)
			{
				try {
					tareas[i].bos().write(buffer,0,msg.length());
	                tareas[i].bos().flush();
	            } catch (IOException e)
		        {
			        System.err.println("Error mientras se escriba");
				}
			}
	    }
	}

	public synchronized void unregister(ConnectionThread thread)
	{
	    int i = 0;
	    while (thread != tareas[i])
	        i++;

        tareas[i] = null;
        Clients--;
	}
}

