package majordomo;

import majordomo.*;
import java.rmi.server.UnicastRemoteObject;
import java.util.*;
import java.rmi.*;
import java.sql.*;

public abstract class GenericRemoteCollection
    extends java.rmi.server.UnicastRemoteObject
    implements majordomo.RemoteCollection
{
    protected Connection con;
    protected Statement st;
    protected ResultSet rs;

    // Las subclases pueden indicar la tabla que abstraen
    protected abstract String tableName();

    public GenericRemoteCollection(String dataSource) 
	throws RemoteException
    {
        super();

        try {
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        } catch (ClassNotFoundException e)
        {
            System.out.println("No se encuentra la clase JdbcOdbcDriver.");
            return;
        }

        try {
            con = DriverManager.getConnection("jdbc:odbc:"+dataSource,"","");
        } catch (java.sql.SQLException e)
        {
            System.err.println("Error: " +e );
            e.printStackTrace();
        }

        st = null;
    }

    protected void finalize() throws Throwable
    {
        try {
            con.close();
            close();
        } catch (java.sql.SQLException ignored)
        {}
    }

    public abstract int remove() throws RemoteException;
    public abstract int add(Object o) throws RemoteException;

    public int first() throws RemoteException
    {
        try {
            if (st != null)
                st.close();

            st = con.createStatement();
            rs = st.executeQuery("select * from " + tableName());
        } catch (java.sql.SQLException e)
        {
            System.err.println("Error: "+e);
            e.printStackTrace();
        }

        return 0;
    }

    public abstract Object nextElement() throws RemoteException;

    public void close() throws RemoteException
    {
        try {        
            if (st != null)
            {
                rs.close();
                st.close();
                st = null;
                rs = null;
            }
        } catch (SQLException e)
        {
            System.err.println("Error: "+e);
            e.printStackTrace();
        }
    }
}
