import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;


public class SubscriptionServlet extends HttpServlet
{
    public void doPost(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
        // Iniciar el tipo MIME del contenido de la respuesta
        res.setContentType("text/html");

        // Obtener el stream de comunicacin con el cliente
        ServletOutputStream out = res.getOutputStream();

        // Obtener los datos del cliente. En este caso, slo nos
        // interesan los campos 'listname' y 'email'.
        String listname = req.getParameterValues("listname")[0];
        String email = req.getParameterValues("email")[0];

        sendHeader(out,"Suscripci&oacute;n a una lista");

        try
        {
            // Aadir al fichero de suscripciones
            FileWriter outFile = new FileWriter("c:\\Amos",true);
            PrintWriter of = new PrintWriter(outFile);
            of.println("\"" + email + "\";\"" + listname + "\"");
            outFile.close();

            out.println("<CENTER>Ha quedado suscrito a la lista " +
                        listname + ".</CENTER>");

        } catch (IOException e) {
            e.printStackTrace();
            out.println("Error accediendo al fichero.");
        }

        sendFooter(out);

        // Terminar la respuesta cerrando el Writer
        out.close();
    }

    private void sendHeader(ServletOutputStream out, String title)
        throws IOException
    {
        FileReader inFileReader = new FileReader("c:\\header.html");
        BufferedReader inFile = new BufferedReader(inFileReader);

        String line;
        String headerInfo = "<!--HEADERINFO-->";
        while (null != (line = inFile.readLine() ))
        {
            int index;

            // Encontrar el identificador "<!--HEADERINFO-->"
            if (-1 != (index = line.indexOf( headerInfo )))
            {
                try {
                    String newLine =
                        line.substring(0,index) +
                        title +
                        line.substring(index + headerInfo.length(),
                                                    line.length());

                    out.println(newLine);
                } catch (Exception ignore)
                {}
            }
            else
            {
                out.println(line);
            }
        }
        inFileReader.close();
    }

    private void sendFooter(ServletOutputStream out) throws IOException
    {
        FileReader inFileReader = new FileReader("c:\\footer.html");
        BufferedReader inFile = new BufferedReader(inFileReader);

        String line;
        while (null != (line = inFile.readLine() ))
        {
            out.println(line);
        }

        inFileReader.close();
    }

    public String getServletInfo()
    {
        return "Servlet de Suscripcin";
    }

}
